=== Clients/CMakeLists.txt ===
add_subdirectory(CommandLineExecutables)
if (PARAVIEW_USE_QT)
  add_subdirectory(ParaView)
endif ()
