=== debian/changelog ===
paraview (5.9.0-2ubuntu1) hirsute; urgency=medium

  * Merge from Debian unstable, remaining changes:
    + Minimize debug symbols to -g1
    + Disable parallel builds

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 10 Apr 2021 07:37:51 +0000

paraview (5.9.0-2) unstable; urgency=medium

  * Ship vtkmodules. This makes python3-paraview conflict with python3-vtk9,
    Closes: #981891
  * Ship paraview-config in paraview-dev pkg

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 10 Feb 2021 13:26:25 +0000

paraview (5.9.0-1) unstable; urgency=medium

  * New upstream release. Closes: #976128, #959387, #976132
  * Ack. bug fixed/obsoleted by new version: Closes: #893735
  * Re-enable gl2ps
  * use Parallel HDF5
  * Build-dep on libopengl-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 29 Jan 2021 09:53:39 +0000

paraview (5.9.0~rc1-1) unstable; urgency=medium

  * New upstream release
  * Don't ship files that are in vtk. Closes: #975004
  * Remove obsolete patches:
    - 0001-ENH-Changes-needed-to-support-Qt-5.11.patch
    - 0001-Fix-StreamLinesRepresentation-plugin-documentation-i.patch
    - disable-local-FindMPI.patch
    - fix_gl2ps_new.patch
    - fix_manpages_errors.patch
    - fix_opengl_arm.patch
    - is-literal.patch
    - override-fix.patch
    - python3.8.patch
    - python3-exact.patch
    - python3-exec-versions.patch
    - reduce_cmake_error.cmake
    - remove_webgl.patch
    - security-format.patch
    - use_system_mpi4py.patch
    - use_system_utf8.patch
    - vtk-cmake-findffmpeg-cmake.patch
    - vtk-exodusII-gcc10.patch
  * Temporarily drop ADIOS support until it builds correctly (see #972420)
  * Move to debhelper compat 13
  * Update installed files, adding d/not-installed
  * Set paraview to Recommend: python3-paraview. Closes: #952382
  * Use dh-sequence-python3, drop --with python in d/rules
  * Add build-dep on libxcursor-dev, libqt5svg5-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 20 Nov 2020 12:46:30 +0000

paraview (5.7.0-5ubuntu1) groovy; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Fix build on armhf by restoring a reworked fix_opengl_arm.patch
    - Minimize debug symbols to -g1
    - Disable parallel builds

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 02 Sep 2020 14:06:43 +0200

paraview (5.7.0-5) unstable; urgency=medium

  * Fixed bugs in paraview-dev and python3-paraview package. Closes #959387.
    Thanks to Jakob Meng.
  * Fix for FTBFS with gcc-10, thanks to Jakob Meng. Closes: #957660

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 31 Aug 2020 10:26:25 +0100

paraview (5.7.0-4ubuntu12) groovy; urgency=medium

  * No-change rebuild against libgdal27

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 21 Jun 2020 23:06:44 +0000

paraview (5.7.0-4ubuntu11) groovy; urgency=medium

  * No-change rebuild against libhdf5-103-1

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 16 May 2020 06:09:20 +0000

paraview (5.7.0-4ubuntu10) groovy; urgency=medium

  * No-change rebuild against libpdal-base10

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 May 2020 19:51:37 +0000
